; This is the source for the Itoa function
;
; George Cross, Borland C++ Tech Support, October 1998
;

.386
.model flat
nosmart
.data
	; szIntStr is the buffer to hold all digits in the largest possible 
	; value in an integer
	;
	; This value is 4294967295. This is 10 digits.  We also need one byte
	; for a negative sign and one for a null terminating zero (C language).

	szSign		db	'-'
	szIntStr 	db	11	 dup(0)   


	; flag for negative
	
	bNeg	db	0	

.code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Itoa  
;	receives an integer, and returns a string representation of it
;
; inputs 
;	eax	the integer to represent as a string
;
; outputs
;	eax	pointer to the string representation of the integer
;

        public Itoa
	Itoa label
	

	; save regs

	push ds
	push edi
	push esi


	; flag if negative and convert to two's complement
	
	cmp eax,-1
	jg NotNegative
	mov bNeg,1
	xor eax,0FFFFFFFFh
	inc eax


NotNegative:

	; convert to characters by iteratively dividing by 10

	mov ebx,10
	xor edi,edi
@@1:
	cdq
	idiv ebx
	add dl,'0'
	mov byte ptr [szIntStr+edi],dl
	inc edi
	test eax,eax
	jnz @@1
	dec edi


	; now reverse order of generated character sequence
	; edi indexes the last character 

	xor esi,esi
@@2:
	mov bl,byte ptr [szIntStr+edi]
	mov al,byte ptr [szIntStr+esi]
	mov byte ptr [szIntStr+edi],al
	mov byte ptr [szIntStr+esi],bl
	dec edi
	inc esi
	cmp edi,esi
	jge @@2

	
	; if the integer is negative, return the offset to the '-' sign
	
	cmp bNeg,1
	jnz ReturnPositive
	mov eax,offset szSign
	jmp Finished


	; otherwise just return the offset of the character sequence

ReturnPositive:
	mov eax,offset szIntStr


Finished:
	pop esi
	pop edi
	pop ds
        ret
end
